FileCleaner (Commons IO 2.5)
Date: 2016-12-01

org.apache.commons.io

## Class FileCleaner

- java.lang.Object
- - org.apache.commons.io.FileCleaner

- Deprecated.
  Use `FileCleaningTracker`

      @Deprecated
      public class FileCleaner
      extends java.lang.Object

  Keeps track of files awaiting deletion, and deletes them when an associated marker object is reclaimed by the garbage collector.

  This utility creates a background thread to handle file deletion. Each file to be deleted is registered with a handler object. When the handler object is garbage collected, the file is deleted.

  In an environment with multiple class loaders (a servlet container, for example), you should consider stopping the background thread if it is no longer needed. This is done by invoking the method `exitWhenFinished()`, typically in `javax.servlet.ServletContextListener.contextDestroyed(javax.servlet.ServletContextEvent)` or similar.

  Version:
    $Id: FileCleaner.java 1680650 2015-05-20 18:36:40Z britter $

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) static FileCleaningTracker` | `theInstance` Deprecated. The instance to use for the deprecated, static methods.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FileCleaner()` Deprecated.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `exitWhenFinished()` Deprecated. Use `FileCleaningTracker.exitWhenFinished()`.
    `static FileCleaningTracker` | `getInstance()` Deprecated. Returns the singleton instance, which is used by the deprecated, static methods.
    `static int` | `getTrackCount()` Deprecated. Use `FileCleaningTracker.getTrackCount()`.
    `static void` | `track(java.io.File file, java.lang.Object marker)` Deprecated. Use `FileCleaningTracker.track(File, Object)`.
    `static void` | `track(java.io.File file, java.lang.Object marker, FileDeleteStrategy deleteStrategy)` Deprecated. Use `FileCleaningTracker.track(File, Object, FileDeleteStrategy)`.
    `static void` | `track(java.lang.String path, java.lang.Object marker)` Deprecated. Use `FileCleaningTracker.track(String, Object)`.
    `static void` | `track(java.lang.String path, java.lang.Object marker, FileDeleteStrategy deleteStrategy)` Deprecated. Use `FileCleaningTracker.track(String, Object, FileDeleteStrategy)`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### theInstance

          static final FileCleaningTracker theInstance

      Deprecated.
      The instance to use for the deprecated, static methods.

  - ### Constructor Detail

    - #### FileCleaner

          public FileCleaner()

      Deprecated.

  - ### Method Detail

    - #### track

          @Deprecated
          public static void track(java.io.File file,
                              java.lang.Object marker)

      Deprecated. Use `FileCleaningTracker.track(File, Object)`.
      Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The `normal` deletion strategy will be used.
      Parameters:
        `file` - the file to be tracked, not null
        `marker` - the marker object used to track the file, not null
      Throws:
        `java.lang.NullPointerException` - if the file is null

    - #### track

          @Deprecated
          public static void track(java.io.File file,
                              java.lang.Object marker,
                              FileDeleteStrategy deleteStrategy)

      Deprecated. Use `FileCleaningTracker.track(File, Object, FileDeleteStrategy)`.
      Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The speified deletion strategy is used.
      Parameters:
        `file` - the file to be tracked, not null
        `marker` - the marker object used to track the file, not null
        `deleteStrategy` - the strategy to delete the file, null means normal
      Throws:
        `java.lang.NullPointerException` - if the file is null

    - #### track

          @Deprecated
          public static void track(java.lang.String path,
                              java.lang.Object marker)

      Deprecated. Use `FileCleaningTracker.track(String, Object)`.
      Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The `normal` deletion strategy will be used.
      Parameters:
        `path` - the full path to the file to be tracked, not null
        `marker` - the marker object used to track the file, not null
      Throws:
        `java.lang.NullPointerException` - if the path is null

    - #### track

          @Deprecated
          public static void track(java.lang.String path,
                              java.lang.Object marker,
                              FileDeleteStrategy deleteStrategy)

      Deprecated. Use `FileCleaningTracker.track(String, Object, FileDeleteStrategy)`.
      Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The speified deletion strategy is used.
      Parameters:
        `path` - the full path to the file to be tracked, not null
        `marker` - the marker object used to track the file, not null
        `deleteStrategy` - the strategy to delete the file, null means normal
      Throws:
        `java.lang.NullPointerException` - if the path is null

    - #### getTrackCount

          @Deprecated
          public static int getTrackCount()

      Deprecated. Use `FileCleaningTracker.getTrackCount()`.
      Retrieve the number of files currently being tracked, and therefore awaiting deletion.
      Returns:
        the number of files being tracked

    - #### exitWhenFinished

          @Deprecated
          public static void exitWhenFinished()

      Deprecated. Use `FileCleaningTracker.exitWhenFinished()`.
      Call this method to cause the file cleaner thread to terminate when there are no more objects being tracked for deletion.

      In a simple environment, you don't need this method as the file cleaner thread will simply exit when the JVM exits. In a more complex environment, with multiple class loaders (such as an application server), you should be aware that the file cleaner thread will continue running even if the class loader it was started from terminates. This can consitute a memory leak.

      For example, suppose that you have developed a web application, which contains the commons-io jar file in your WEB-INF/lib directory. In other words, the FileCleaner class is loaded through the class loader of your web application. If the web application is terminated, but the servlet container is still running, then the file cleaner thread will still exist, posing a memory leak.

      This method allows the thread to be terminated. Simply call this method in the resource cleanup code, such as `javax.servlet.ServletContextListener.contextDestroyed(javax.servlet.ServletContextEvent)`. One called, no new objects can be tracked by the file cleaner.

    - #### getInstance

          public static FileCleaningTracker getInstance()

      Deprecated.
      Returns the singleton instance, which is used by the deprecated, static methods. This is mainly useful for code, which wants to support the new `FileCleaningTracker` class while maintain compatibility with the deprecated `FileCleaner`.
      Returns:
        the singleton instance

Copyright (c) 2002-2016 Apache Software Foundation